c
c**********************************************************************************
c
C        New subroutine for reading the data files
      SUBROUTINE DATAREAD(JDS,IDSZ,NFMT,LSYNC,LMR,ERROR)
      include 'param.inc'
      INTEGER IOUNIT,NFMT,LSYNC,LC,ERROR
      CHARACTER FNAME*64,CEXT*4,FTEMP*64
      COMMON/FILEINT/LC,FNAME,FTEMP
C
      ERROR = 0
      IOUNIT = 4                          
      IOBCK = 2 
    5 format(' Reading datafile ',I2)                                          !open for the first time
      IF (JDS.EQ.1) THEN
          open(unit=IOUNIT,file=FNAME(1:LC)//'.dat',status='OLD'
     *              ,ERR=10)
          WRITE(7,5) JDS
      ELSE
          IF (LMR.NE.0) THEN
              WRITE(7,5) JDS                                                  !REOPEN IF IN
              CEXT='.d'                                                       !ANOTHER FILE
              IF (JDS.LE.9) THEN
                  CEXT(3:3) = CHAR(JDS+48)
              ELSE
                  CEXT(3:3) = CHAR( INT(JDS/10) + 48)
                  CEXT(4:4) = CHAR( MOD(JDS,10) + 48)                         !I HOPE !!!
              ENDIF
              OPEN(UNIT=IOUNIT,FILE=FNAME(1:LC)//CEXT,STATUS='OLD',
     *             ERR=10)                                       
          ENDIF
      ENDIF
      IF (NFMT.LE.3) THEN
          CALL READFORM(IOUNIT,IDSZ,LSYNC,NFMT,ERROR,JDS)
      ELSE                           
          CALL READFREE(IOUNIT,IDSZ,NFMT,ERROR,JDS)
      ENDIF   
      IF (ERROR.NE.0) GOTO 20
      IF (LMR.NE.0) CLOSE(UNIT=IOUNIT)
      RETURN

   10 CONTINUE
      ERROR = 6
      WRITE(7,*) 'ERROR OPENING DATAFILE'
      RETURN
   20 CONTINUE
      IF (ERROR.EQ.22) THEN
          write(7,*) 'ERROR IN THETA ANGLES OF DATA FILE OR TITLE'
      ENDIF
      IF (ERROR.EQ.21) THEN
          write(7,*) 'ERROR IN THE DATA LINES OF DATA FILE'
      ENDIF
      IF (ERROR.EQ.23) THEN
          write(7,*) 'ERROR NOT IMPLEMENTED'
      ENDIF
C   
      RETURN
      END                               
c
c**********************************************************************************
c
C         ROUTINUE TO READ FORMATED DATA
      SUBROUTINE READFORM(IOUNIT,IDSZ,LSYNC,NFMT,ERROR,JDS)
      INCLUDE 'param.inc'
      INTEGER IOUNIT,LSYNC,FSP,FSPW,NFMT,JDS,ERROR,IDSZ
      INTEGER IBANK,NCHAN,NREC
      CHARACTER BINTYP,TITLE*80,CBANK
      REAL BCOEF(4)
      REAL THMIN2,THMAX2,STEP2,LAMDA,HWMAX
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS)
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      CHARACTER GTYPE*3
C      COMMON/DATAX/Y(MAXDS,IDSZ),YC(MAXDS,IDSZ),KR(MAXDS,IDSZ),
C     *             BK(MAXDS,IDSZ),NPTS(MAXDS),WT(MAXDS,IDSZ)
C      
      ERROR = 0
      IF (NFMT.EQ.3) THEN
          READ(IOUNIT,'(A)',END=99997) TITLE                                      !GSAS
          READ(IOUNIT,*,END=99997) CBANK,IBANK,NCHAN,NREC,BINTYP,
     *                              (BCOEF(I),I=1,4),GTYPE
          THMIN2 = BCOEF(1)/100.0
          STEP2 = BCOEF(2)/100.0
          NPTSD = NCHAN
          THMAX2 = THMIN2 + (NPTSD-1)*STEP2
          IF (GTYPE.EQ.'ESD') THEN                                                !GSAS 'ESD' FORMAT
             READ(IOUNIT,200,END=99998)(Y(JDS,I),WT(JDS,I),I=1,NPTSD)
             DO I =1,NPTSD
                IF (WT(JDS,I).EQ.0) THEN
                   WT(JDS,I) = 1.0
                ELSE
                   WT(JDS,I) = 1/(WT(JDS,I)*WT(JDS,I))
                ENDIF
             ENDDO                                                                !GSAS 'STD' FORMAT
          ELSE
             READ(IOUNIT,20,END=99998)(WT(JDS,I),Y(JDS,I),I=1,NPTSD)
             DO I =1,NPTSD
                IF (WT(JDS,I).EQ.0) THEN
                   WT(JDS,I) = 1.0
                ENDIF
             ENDDO
	    ENDIF
  200 FORMAT(10F8.0)
      ELSE
          IF ((LSYNC.EQ.0).AND.(NFMT.NE.2)) THEN
             READ(IOUNIT,10,END=99997)THMIN2,STEP2,THMAX2                    !old data format
          ELSE
             READ(IOUNIT,*,END=99997)THMIN2,STEP2,THMAX2                     !new for sync
          ENDIF                                                                 !and others
C             number of points in data file   
          NPTSD= INT((THMAX2-THMIN2)/STEP2 + 1.5)
      ENDIF
C
      IF (THMIN(JDS).EQ.0.0) THEN                                          !refinement = all data
          THMIN(JDS)=THMIN2                                                !reset the theta values to the data ones
          THMAX(JDS)=THMAX2
          STEP(JDS)=STEP2
      ENDIF            
C             check stepsize and force the be equal to data step
      IF (STEP(JDS).NE.STEP2) WRITE(7,60) STEP2,STEP(JDS)
      STEP(JDS) = STEP2
C             use a crude FWHM
      HWMAX = 2.0                                                 
c             maximum number of points allowed to be read in (to allow space for exculed regions
      MAXPTS = IDSZ - INT(HWMAX*WDT(JDS)/(2.0*STEP2)+0.5)         
c             reset the number of points to the equal to the maximum number of points and a new thmax2
      IF (NPTSD.GT.MAXPTS) THEN
          NPTSD = MAXPTS
          THMAX2 = THMIN2 + STEP(JDS)*(MAXPTS-1)
          IF (JDS.GT.1)write(7,*)'NEED TO INCREASE MAXPTS'
      ENDIF                                                                                           
C             read in data (reads in all the possible data)
      IF (NFMT.LE.2) THEN
         ASSIGN 20 TO FSP                                                    !DEFAULT FOR NFMT = 0
         ASSIGN 25 TO FSPW
         IF (NFMT.EQ.1) THEN 
            ASSIGN 30 TO FSP
            ASSIGN 35 TO FSPW
         ENDIF              
         IF (NFMT.EQ.2) THEN
            ASSIGN 300 TO FSP
            ASSIGN 350 TO FSPW
         ENDIF              
c                                                                 
         WRITE(6,FSPW)

         IF (NFMT.LE.1) THEN
           READ(IOUNIT,FSP,END=99998,ERR=99998)(WT(JDS,I),Y(JDS,I),
     *                                          I=1,NPTSD)
         ELSE
           READ(IOUNIT,FSP,END=99998,ERR=99998)(Y(JDS,I),I=1,NPTSD)
         ENDIF                          
         IF (NFMT.EQ.2) THEN
           DO I=1,NPTSD
              WT(JDS,I) = 1/Y(JDS,I)
           ENDDO
         ENDIF
      ENDIF
c             reshuffle the data to the required length

      IF (THMAX2.LT.THMAX(JDS)) THMAX(JDS) = THMAX2
      IF (THMIN(JDS).LE.THMIN2) THEN
          THMIN(JDS) = THMIN2
          NPTS(JDS)=(THMAX(JDS)-THMIN(JDS))/STEP(JDS)+1.5
      ELSE
          NPTS(JDS)=(THMAX(JDS)-THMIN(JDS))/STEP(JDS)+1.5
          NSKIP=(THMIN(JDS)-THMIN2)/STEP(JDS)
          DO 1010 I=1,NPTS(JDS)
              IF (WT(JDS,I).EQ.0) WT(JDS,I) = 1
              WT(JDS,I)=WT(JDS,I+NSKIP)
 1010         Y(JDS,I)=Y(JDS,I+NSKIP)
      ENDIF
C                                               
      WRITE(6,40) JDS,THMIN(JDS),THMAX(JDS),STEP(JDS)
      GOTO 50
C      
   10 FORMAT(BZ,3F8.3)
C   15 FORMAT(4X,3I,A,4G)
   30 FORMAT(BZ,10(F1.0,F7.0))
   20 FORMAT(BZ,10(F2.0,F6.0))
  300 FORMAT(BZ,10F8.1)
   25 FORMAT(' HISTOGRAM READ IN FORMAT 10(I2,I6)')
   35 FORMAT(' HISTOGRAM READ IN FORMAT 10(I1,I7)')
  350 FORMAT(' HISTOGRAM READ IN FORMAT 10F8')
   40 FORMAT(' HISTOGRAM ',I2,' FROM ',F15.6,' TO ',F15.6,
     *' IN STEPS OF ',F12.6,' DEGREES')
   60 FORMAT(' *** Warning *** Step size in DATA file:',f12.6,/,
     * ' and INPUT file step:',f12.6,' are not equivalent')
C         simple error routine
99997 ERROR=22                                                             !ERROR IN THETA LINE
      GOTO 50
99998 ERROR=21                                                             !ERROR IN DATA
      GOTO 50
99996 ERROR=23
C
   50 RETURN
      END
c
c**********************************************************************************
c
C     ROUTINUE TO READ UNFORMATED/FREELIST DATA
      SUBROUTINE READFREE(IOUNIT,IDSZ,NFMT,ERROR,JDS)
      INCLUDE 'param.inc'
      INTEGER IOUNIT,NFMT,ERROR,JDS,I,IDSZ
      REAL OLDANG,ANGLE,THMIN2,STEP2,THMAX2
      CHARACTER TITLE*80
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS)
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
C      COMMON/DATAX/Y(MAXDS,IDSZ),YC(MAXDS,IDSZ),KR(MAXDS,IDSZ),
C     *             BK(MAXDS,IDSZ),NPTS(MAXDS),WT(MAXDS,IDSZ)
C
      READ(IOUNIT,'(A80)',ERR=110) TITLE 
      IF (NFMT.EQ.4) THEN
          WRITE(6,200)
      ELSE
          WRITE(6,300)
      ENDIF
C             read in data
      I = 1
      OLDANG = 0.0
   10 IF (NFMT.EQ.4) THEN
          READ(IOUNIT,*,ERR=35,END=30) ANGLE,Y(JDS,I),WT(JDS,I)
      ELSE
          READ(IOUNIT,*,ERR=35,END=30) ANGLE,Y(JDS,I)
      ENDIF          
      IF (ANGLE.LT.0.0) GOTO 10
      IF (ANGLE.EQ.-1.0) GOTO 30
      OLDANG = ANGLE
      IF (I.EQ.1) THMIN2 = ANGLE
	IF (NFMT.NE.4) THEN
          IF (Y(JDS,I).GT.0.0) THEN
              WT(JDS,I) = 1/Y(JDS,I)
          ELSE
              WT(JDS,I) = -1.0
          ENDIF
      ENDIF
      IF (I.EQ.IDSZ) GOTO 30
      I = I + 1                            
      GOTO 10  
C
   35 BACKSPACE(IOUNIT)                                                   !if errored then we have hit the next title
   30 THMAX2 = OLDANG
      NPTS2 = I-1
      STEP2 = (THMAX2 - THMIN2)/(NPTS2-1)
      IF (STEP(JDS).NE.STEP2) WRITE(7,60) STEP2,STEP(JDS)
      STEP(JDS) = STEP2
c
      IF (THMIN(JDS).EQ.0.0) THEN                                         !SET UP IF WE WANT TO DEFAULT
          THMIN(JDS)=THMIN2
          THMAX(JDS)=THMAX2
      ENDIF                                                          
C
      IF (THMAX2.LE.THMAX(JDS)) THMAX(JDS) = THMAX2
      IF (THMIN(JDS).LE.THMIN2) THEN                
          THMIN(JDS) = THMIN2
          NPTS(JDS)=(THMAX(JDS)-THMIN(JDS))/STEP(JDS)+1.5
      ELSE
          NPTS(JDS)=(THMAX(JDS)-THMIN(JDS))/STEP(JDS)+1.5
          NSKIP=(THMIN(JDS)-THMIN2)/STEP(JDS)
          DO 1020 I=1,NPTS(JDS)
              WT(JDS,I)=WT(JDS,I+NSKIP)
 1020         Y(JDS,I)=Y(JDS,I+NSKIP)
      ENDIF           
      WRITE(6,400) JDS,THMIN(JDS),THMAX(JDS),STEP(JDS)
      GOTO 50                   
c
  110 ERROR = 22        
c  
   60 FORMAT(' *** Warning *** Step size in DATA file:',f12.6,/,
     * ' and INPUT file step:',f12.6,' are not equivalent')
  200 FORMAT(' HISTOGRAM READ IN AS (2THETA, INTENSITY, W(INTENSITY)')
  300 FORMAT(' HISTOGRAM READ IN AS (2THETA, INTENSITY)')
  400 FORMAT(' HISTOGRAM ',I2,' FROM ',F15.6,' TO ',F15.6,
     *' IN STEPS OF ',F12.6,' DEGREES')
C
   50 RETURN
      END

